# coding: utf-8

"""
    API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from testit_api_client.models.test_suite_type import TestSuiteType
from typing import Optional, Set
from typing_extensions import Self

class TestSuiteV2GetModel(BaseModel):
    """
    TestSuiteV2GetModel
    """ # noqa: E501
    id: StrictStr = Field(description="Unique ID of the test suite")
    refresh_date: Optional[datetime] = Field(default=None, description="Date of the last refresh of the test suite", alias="refreshDate")
    parent_id: Optional[StrictStr] = Field(default=None, description="Unique ID of the parent test suite in hierarchy", alias="parentId")
    test_plan_id: StrictStr = Field(description="Unique ID of test plan to which the test suite belongs", alias="testPlanId")
    name: Annotated[str, Field(min_length=0, strict=True, max_length=255)] = Field(description="Name of the test suite")
    type: Optional[TestSuiteType] = Field(default=None, description="Type of the test suite")
    save_structure: Optional[StrictBool] = Field(default=None, description="Indicates if the test suite retains section tree structure", alias="saveStructure")
    auto_refresh: Optional[StrictBool] = Field(default=None, description="Indicates if scheduled auto refresh is enabled for the test suite", alias="autoRefresh")
    __properties: ClassVar[List[str]] = ["id", "refreshDate", "parentId", "testPlanId", "name", "type", "saveStructure", "autoRefresh"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TestSuiteV2GetModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if refresh_date (nullable) is None
        # and model_fields_set contains the field
        if self.refresh_date is None and "refresh_date" in self.model_fields_set:
            _dict['refreshDate'] = None

        # set to None if parent_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_id is None and "parent_id" in self.model_fields_set:
            _dict['parentId'] = None

        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        # set to None if save_structure (nullable) is None
        # and model_fields_set contains the field
        if self.save_structure is None and "save_structure" in self.model_fields_set:
            _dict['saveStructure'] = None

        # set to None if auto_refresh (nullable) is None
        # and model_fields_set contains the field
        if self.auto_refresh is None and "auto_refresh" in self.model_fields_set:
            _dict['autoRefresh'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TestSuiteV2GetModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "refreshDate": obj.get("refreshDate"),
            "parentId": obj.get("parentId"),
            "testPlanId": obj.get("testPlanId"),
            "name": obj.get("name"),
            "type": obj.get("type"),
            "saveStructure": obj.get("saveStructure"),
            "autoRefresh": obj.get("autoRefresh")
        })
        return _obj


